DECLARE @tempTable TABLE ([SalesPerson] varchar(50))
INSERT INTO @tempTable
SELECT SalesPerson
FROM Sales
GROUP BY SalesPerson

DECLARE @pivotCols varchar(MAX)
SELECT @pivotCols = COALESCE(@pivotCols + ', [' + SalesPerson + ']', '[' + SalesPerson + ']') FROM @tempTable

DECLARE @selectCols varchar(MAX)
SELECT @selectCols = COALESCE(@selectCols + ', ISNULL([' + SalesPerson + '], 0) AS [' + SalesPerson + ']', 'ISNULL([' + SalesPerson + '], 0) AS [' + SalesPerson + ']') FROM @tempTable

DECLARE @query nvarchar(MAX)
SET @query = '
	SELECT Month, ' + @selectCols + '
	FROM
	(
		SELECT MONTH(SalesDate) AS Month, SalesPerson, SUM(SalesAmount) AS SalesAmount
		FROM Sales
		GROUP BY MONTH(SalesDate), SalesPerson
	) S
	PIVOT
	(
		SUM(S.SalesAmount) FOR [SalesPerson] IN (' + @pivotCols + ')
	) P'

EXECUTE sp_executesql @query 
